"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const HTMLElement_class_1 = require("./HTMLElement.class");
const HTMLTemplateElement_class_1 = require("./HTMLTemplateElement.class");
const path = require('path');
class xjs_HTMLOListElement extends HTMLElement_class_1.default {
    static async template() {
        return HTMLTemplateElement_class_1.default.fromFile(path.join(__dirname, '../../src/tpl/x-htmlolistelement.tpl.html'));
    }
    static templateSync() {
        return HTMLTemplateElement_class_1.default.fromFileSync(path.join(__dirname, '../../src/tpl/x-htmlolistelement.tpl.html'));
    }
    constructor(node) {
        super(node);
    }
    get node() { return super.node; }
    populate(dataset, renderer = (f, d, o) => { }, this_arg = this, options = {}) {
        let template = this.node.querySelector('template');
        if (template === null) {
            throw new ReferenceError('This <ol> does not have a <template> descendant.');
        }
        if (template.content.children.length !== 1 || !template.content.children[0].matches('li')) {
            throw new ReferenceError('The <template> must contain exactly 1 element, which must be an <li>.');
        }
        let component = new HTMLTemplateElement_class_1.default(template).setRenderer(renderer);
        return this.append(...dataset.map((data) => component.render(data, this_arg, options)));
    }
}
exports.default = xjs_HTMLOListElement;
