"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const DocumentFragment_class_1 = require("./DocumentFragment.class");
const HTMLElement_class_1 = require("./HTMLElement.class");
class xjs_HTMLTemplateElement extends HTMLElement_class_1.default {
    static async fromFile(filepath) {
        let elem = (await DocumentFragment_class_1.default.fromFile(filepath)).node.querySelector('template');
        if (elem === null) {
            throw new ReferenceError(`No \`template\` element was found in file: ${filepath}`);
        }
        return new xjs_HTMLTemplateElement(elem);
    }
    static fromFileSync(filepath) {
        let elem = DocumentFragment_class_1.default.fromFileSync(filepath).node.querySelector('template');
        if (elem === null) {
            throw new ReferenceError(`No \`template\` element was found in file: ${filepath}`);
        }
        return new xjs_HTMLTemplateElement(elem);
    }
    constructor(node) {
        super(node);
        this._renderer = (f, d, o) => { };
    }
    get node() { return super.node; }
    content() {
        return this.node.content;
    }
    setRenderer(renderer) {
        this._renderer = renderer;
        return this;
    }
    render(data, this_arg = null, options = {}) {
        let frag = this.content().cloneNode(true);
        this._renderer.call(this_arg, frag, data, options);
        return frag;
    }
}
exports.default = xjs_HTMLTemplateElement;
