"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var NodeType;
(function (NodeType) {
    NodeType[NodeType["ELEMENT_NODE"] = 1] = "ELEMENT_NODE";
    NodeType[NodeType["ATTRIBUTE_NODE"] = 2] = "ATTRIBUTE_NODE";
    NodeType[NodeType["TEXT_NODE"] = 3] = "TEXT_NODE";
    NodeType[NodeType["CDATA_SECTION_NODE"] = 4] = "CDATA_SECTION_NODE";
    NodeType[NodeType["ENTITY_REFERENCE_NODE"] = 5] = "ENTITY_REFERENCE_NODE";
    NodeType[NodeType["ENTITY_NODE"] = 6] = "ENTITY_NODE";
    NodeType[NodeType["PROCESSING_INSTRUCTION_NODE"] = 7] = "PROCESSING_INSTRUCTION_NODE";
    NodeType[NodeType["COMMENT_NODE"] = 8] = "COMMENT_NODE";
    NodeType[NodeType["DOCUMENT_NODE"] = 9] = "DOCUMENT_NODE";
    NodeType[NodeType["DOCUMENT_TYPE_NODE"] = 10] = "DOCUMENT_TYPE_NODE";
    NodeType[NodeType["DOCUMENT_FRAGMENT_NODE"] = 11] = "DOCUMENT_FRAGMENT_NODE";
    NodeType[NodeType["NOTATION_NODE"] = 12] = "NOTATION_NODE";
})(NodeType || (NodeType = {}));
class xjs_Node {
    constructor(node) {
        this._NODE = node;
    }
    get node() { return this._NODE; }
    textContent(text) {
        if (arguments.length) {
            this.node.textContent = text;
            return this;
        }
        return this.node.textContent;
    }
    exe(executable) {
        executable.call(this);
        return this;
    }
    trimInner() {
        [...this.node.childNodes].forEach((child) => {
            if (child.nodeType === xjs_Node.NodeType.TEXT_NODE && child.textContent.trim() === '')
                child.remove();
            else if (child.nodeType === xjs_Node.NodeType.ELEMENT_NODE)
                new xjs_Node(child).trimInner();
        });
        return this;
    }
    empty() {
        [...this.node.childNodes].forEach((child) => {
            child.remove();
        });
        return this;
    }
}
xjs_Node.NodeType = NodeType;
exports.default = xjs_Node;
