const fs = require('fs')
const util = require('util')

const jsdom = require('jsdom')

const xjs = require('extrajs')

const dom = new jsdom.JSDOM(``, {
  contentType: "text/xml",
})
const {document} = dom.window

function json_to_xml(thing) {
  if (xjs.Object.typeOf(thing) === 'array') {
    return thing.map((item) => json_to_xml(item))
  } else if (xjs.Object.typeOf(thing) === 'object') {
    if (!thing['@type']) throw new Error(`\`${thing}\` has no value for \`@type\`.`)
    let element = document.createElement(thing['@type'])
    if (thing['@id']) element.id = thing['@id']
    for (let i in thing) {
      if (i[0] !== '@') {
        let children = json_to_xml(thing[i])
        if (xjs.Object.typeOf(children) !== 'array') children = [children]
        children.forEach((child) => { child.setAttribute('prop', i) })
        element.append(...children)
      }
    }
    return element
  } else {
    let type = ({
      'string': () => 'Text',
      'number': () => ({
        'integer': () => 'Integer',
        'float'  : () => 'Float',
      })[xjs.Number.typeOf(thing)].call(null) || 'Number',
      'boolean': () => 'Boolean',
      'null': () => 'Null'
      // Date
      // DateTime
      // Time
    })[xjs.Object.typeOf(thing)].call(null) || null
    if (!type) throw new Error(`Could not identify type of \`${type}\`.`)
    let element = document.createElement(type)
    element.textContent = thing
    return element
  }
}


let args = {
  neo: [
    '/Users/Chris/Repositories/_CLONED/neo/proto/asce-event.org/database.jsonld',
    '/Users/Chris/Repositories/_CLONED/neo/proto/asce-event.org/database.xml',
  ],
  cont: [
    '/Users/Chris/Repositories/continuum/_models/site.json',
    '/Users/Chris/Repositories/continuum/_models/site.xml',
  ],
}

;(async function (inputpath, outputpath) {
  const data = JSON.parse(await util.promisify(fs.readFile)(inputpath))
  document.append(json_to_xml(data))
  return util.promisify(fs.writeFile)(outputpath, dom.serialize())
})(...args.neo)
  .catch((err) => { console.error(err) })
  .then(() => { console.log('XML file written successfully!') })
